package nxm.audio.lib;


public class AudioFormat {

  float frameRate;
  float sampleRate;
  int sampleSizeInBits;
  int channels;
  int frameSize;
  boolean signed;
  boolean bigEndian;

  public AudioFormat(float sampleRate, int sampleSizeInBits,
                     int channels, boolean signed, boolean bigEndian) {

    this.sampleRate = sampleRate;
    this.sampleSizeInBits = sampleSizeInBits;
    this.channels = channels;
    this.signed = signed;
    this.bigEndian = bigEndian;
    this.frameSize = sampleSizeInBits * channels / 8;
    this.frameRate = sampleRate;
  }

  public int getChannels() {
    return channels;
  }

  public int getFrameSize() {
    return frameSize;
  }

  public float getFrameRate() {
    return frameRate;
  }

  public float getSampleRate() {
    return sampleRate;
  }

  public int getSampleSizeInBits() {
    return sampleSizeInBits;
  }
 
  public boolean isBigEndian() {
    return bigEndian;
  }

}

