package nxm.audio.net;

import java.rmi.Remote;
import java.rmi.RemoteException;

/**
   public interface to Remote Player Delegate.
   @author Lisa Tursky
*/
public interface PlayerIntf extends Remote {
    public int addReader(String host,int port,String audiotype,int bufferSize) throws RemoteException;
    public void removeReader(int channel) throws RemoteException;
    public float getVolume(int lineNum) throws RemoteException;
    public float getPan(int lineNum) throws RemoteException;
    public boolean getOff(int lineNum) throws RemoteException;
    public void setVolumeRemote(int volume, int lineNum) throws RemoteException;
    public void setVolumeRemote(int volume, int lineNum, boolean convert) throws RemoteException;
    public void setPanRemote(float pan, int lineNum) throws RemoteException;
    public void setPanRemote(float pan, int lineNum, boolean convert) throws RemoteException;
    public void setOffRemote(boolean off, int lineNum) throws RemoteException;
    public void close() throws RemoteException;
    public void shutdown() throws RemoteException;
    public void isAlive() throws RemoteException;
    public void setHostPort(String host,int port,int channel,String audiotype,boolean on) throws RemoteException;
    public String getName() throws RemoteException;
    public String getPlayerChannelInfo() throws RemoteException;
}
