package nxm.sys.inc;

import nxm.sys.libg.GWidget;

/**
  Interface Definitions for Widget Panels.

  @author Jeff Schoen
  @version $Id: WidgetPanel.java,v 1.6 2014/10/21 18:43:28 ntn Exp $
*/
public interface WidgetPanel {

  /** Adds a widget to the panel. <br>
      <b>Note:</b> To avoid a possible race condition, this method should always be called by the EDT.

      @param obj The widget to add.
      @return <code>obj</code> after it has been added.
   */
  Object addWidget (GWidget obj);

  /** Layout widget panel.
      @param obj The widget to layout in the panel.
   */
  void layoutWidget (GWidget obj);

}
