package nxm.sys.intr;

import nxm.sys.lib.*;

/** Handle a block ELSE control statement. <br>
    <br>
    The {@link If} intrinsic handles selection of the proper branch in an
    IF..ELSEIF..ELSE..ENDIF block, so this simply serves as an indicator that
    the preceding IF (or ELSEIF) is complete, and branches the code to the ENDIF.

    @author Jeff Schoen
    @version $Id: Else.java,v 1.6 2012/12/22 00:48:42 jxc Exp $
 */
public class Else extends Intrinsic {
  @Override
  public int process () {
    if (M.macro!=null) {
      M.macro.nextIndex=nextIndex;
    }
    return FINISH;
  }
}
