package nxm.sys.lib;

/**
  A sorted list class (used in primitive peakpick)

  @author Ken Smith
  @version $Id: Sorter.java,v 1.2 2013/10/03 12:51:59 ntn Exp $
 */
public class Sorter {

  public int size;
  private float key_vector[];
  private float val_vector[];
  private static final float invalid = -1.E20f;

  // Constructor
  public Sorter (int size) {
    this.size = size;
    key_vector = new float[size];
    val_vector = new float[size];
  }

  /** Initialize arrays (Java initialization values aren't appropriate). */
  public void init() {
    for (int i = 0; i < size; i++) {
      key_vector[i] = invalid;
      val_vector[i] = invalid;
    }
  }

  /** Add an entry into the sorted list. */
  public void add (float key, float val) {
    int i;

    // Find where to insert the value
    i = 0;
    while ( (key_vector[i] != invalid) && (key < key_vector[i]) ) {
      i++;
      if (i >= size) return;
    }

    // Move the array up to accommodate the new entry
    for (int j=size-1; j>i; j--) {
      key_vector[j] = key_vector[j-1];
      val_vector[j] = val_vector[j-1];
    }
    key_vector[i] = key;
    val_vector[i] = val;

    return;
  }

  /** Retrieve a specified entry, with default if not found. */
  public float getKey (int index, float defVal) {
    if (key_vector[index] != invalid) {
      return key_vector[index];
    } else {
      return defVal;
    }
  }

  public float getVal (int index, float defVal) {
    if (val_vector[index] != invalid) {
      return val_vector[index];
    } else {
      return defVal;
    }
  }
}
