package nxm.sys.libg;

import nxm.sys.inc.*;
import nxm.sys.lib.Shell;

import java.awt.*;

/** A class to handle a MJText area in its own MWindow
    @author  Jeff Schoen
    @version $Id: MWText.java,v 1.7 2014/04/17 14:39:47 adw Exp $
*/
public class MWText extends MWindow {
  
  @InternalUseOnly
  public MJText mtext;

  /** Creates a new instance.
      @param name   The name of the window.
      @param parent The window's message handler.
   */
  public MWText (String name, int lines, int rows, int cols, int fontsize, 
      int flags, MessageHandler parent) {
    super(name,parent);
    if (!Shell.isHeadless()) { // Since NeXtMidas 3.5.0. Skip if in Headless state. BUG 2817
      setupText(lines,rows,cols,fontsize,flags);
    }
  }
  
  /** Setup the MJText */
  private void setupText (int lines, int rows, int cols, int fontsize,
      int flags) {
    mtext = new MJText(lines,rows,cols,fontsize,Theme.global(),flags);
    panel = (Container)mtext;
    setSize (mtext.getWidth(),mtext.getHeight());
    mtext.setMWindow(this);
  }
  
  public void setTheme (Theme theme) {
    super.setTheme(theme);
    if (mtext!=null) mtext.setTheme(theme);
  }

}

