package nxm.sys.libm;

import nxm.sys.inc.*;

/**
   Performs the Noop operation on arrays. <br>
   See {@link Operator} for a description of the available I/O Modes.
   @author  Auto-Generated
   @see     Operator
*/
@SuppressWarnings("cast")
public final class Noop extends Operator implements Constants {

  /** Create a new instance. */
  public Noop() {
    super();
  }

  /** Create a new instance.
      @param flags The processing flags to use.
   */
  public Noop (int flags) {
    super(flags);
  }

  /** Create a new instance.
      @param scale The scale factor to use.
   */
  public Noop (double scale) {
    super(scale);
  }

  /** Create a new instance.
      @param flags The processing flags to use.
      @param scale The scale factor to use.
   */
  public Noop (int flags, double scale) {
    super(flags,scale);
  }

  public final int validate (char type, int n, int mode) {
    switch (mode) {
      case SS: return n;
      case CC: return n;
      case VV: return n;
      default: return NOSUPPORT;
    }
  }

  public final int process (double[][] v, int n, int mode) {
    switch (mode) {
      case SS: SS(v[0],v[1],n); return n;
      case CC: CC(v[0],v[1],n); return n;
      case VV: VV(v[0],v[1],n); return n;
      default:  return NOSUPPORT;
    }
  }

  public final int process (double[][] v, int n, int mode, double scale) {
    switch (mode) {
      case SS: SS(v[0],v[1],n); return n;
      case CC: CC(v[0],v[1],n); return n;
      case VV: VV(v[0],v[1],n); return n;
      default:  return NOSUPPORT;
    }
  }

  /** Apply this operator to mode {@link Operator#SS} data.
      @param a     The first  operand.
      @param b     The second  operand.
      @param n     The number of elements to operate on.
      @see #process(double[][],int,int)
   */
  public static final void SS (double[] a, double[] b, int n) {
      for (int i=0; i<n; i++) {
        b[i]=a[i];
      }
  }

  /** Apply this operator to mode {@link Operator#CC} data.
      @param a     The first  operand.
      @param b     The second  operand.
      @param n     The number of elements to operate on.
      @see #process(double[][],int,int)
   */
  public static final void CC (double[] a, double[] b, int n) {
      for (int i=0,j=0; i<n; i++,j+=2) {
        b[j]=a[j]; b[j+1]=a[j+1];
      }
  }

  /** Apply this operator to mode {@link Operator#VV} data.
      @param a     The first  operand.
      @param b     The second  operand.
      @param n     The number of elements to operate on.
      @see #process(double[][],int,int)
   */
  public static final void VV (double[] a, double[] b, int n) {
      for (int i=0,k=0; i<n; i++,k+=3) {
        b[k]=a[k]; b[k+1]=a[k+1]; b[k+2]=a[k+2];
      }
  }

  public final int process (float[][] v, int n, int mode) {
    switch (mode) {
      case SS: SS(v[0],v[1],n); return n;
      case CC: CC(v[0],v[1],n); return n;
      case VV: VV(v[0],v[1],n); return n;
      default:  return NOSUPPORT;
    }
  }

  public final int process (float[][] v, int n, int mode, double scale) {
    switch (mode) {
      case SS: SS(v[0],v[1],n); return n;
      case CC: CC(v[0],v[1],n); return n;
      case VV: VV(v[0],v[1],n); return n;
      default:  return NOSUPPORT;
    }
  }

  /** Apply this operator to mode {@link Operator#SS} data.
      @param a     The first  operand.
      @param b     The second  operand.
      @param n     The number of elements to operate on.
      @see #process(float[][],int,int)
   */
  public static final void SS (float[] a, float[] b, int n) {
      for (int i=0; i<n; i++) {
        b[i]=a[i];
      }
  }

  /** Apply this operator to mode {@link Operator#CC} data.
      @param a     The first  operand.
      @param b     The second  operand.
      @param n     The number of elements to operate on.
      @see #process(float[][],int,int)
   */
  public static final void CC (float[] a, float[] b, int n) {
      for (int i=0,j=0; i<n; i++,j+=2) {
        b[j]=a[j]; b[j+1]=a[j+1];
      }
  }

  /** Apply this operator to mode {@link Operator#VV} data.
      @param a     The first  operand.
      @param b     The second  operand.
      @param n     The number of elements to operate on.
      @see #process(float[][],int,int)
   */
  public static final void VV (float[] a, float[] b, int n) {
      for (int i=0,k=0; i<n; i++,k+=3) {
        b[k]=a[k]; b[k+1]=a[k+1]; b[k+2]=a[k+2];
      }
  }

  public final int process (int[][] v, int n, int mode) {
    switch (mode) {
      case SS: SS(v[0],v[1],n); return n;
      case CC: CC(v[0],v[1],n); return n;
      case VV: VV(v[0],v[1],n); return n;
      default:  return NOSUPPORT;
    }
  }

  public final int process (int[][] v, int n, int mode, double scale) {
    switch (mode) {
      case SS: SS(v[0],v[1],n); return n;
      case CC: CC(v[0],v[1],n); return n;
      case VV: VV(v[0],v[1],n); return n;
      default:  return NOSUPPORT;
    }
  }

  /** Apply this operator to mode {@link Operator#SS} data.
      @param a     The first  operand.
      @param b     The second  operand.
      @param n     The number of elements to operate on.
      @see #process(int[][],int,int)
   */
  public static final void SS (int[] a, int[] b, int n) {
      for (int i=0; i<n; i++) {
        b[i]=a[i];
      }
  }

  /** Apply this operator to mode {@link Operator#CC} data.
      @param a     The first  operand.
      @param b     The second  operand.
      @param n     The number of elements to operate on.
      @see #process(int[][],int,int)
   */
  public static final void CC (int[] a, int[] b, int n) {
      for (int i=0,j=0; i<n; i++,j+=2) {
        b[j]=a[j]; b[j+1]=a[j+1];
      }
  }

  /** Apply this operator to mode {@link Operator#VV} data.
      @param a     The first  operand.
      @param b     The second  operand.
      @param n     The number of elements to operate on.
      @see #process(int[][],int,int)
   */
  public static final void VV (int[] a, int[] b, int n) {
      for (int i=0,k=0; i<n; i++,k+=3) {
        b[k]=a[k]; b[k+1]=a[k+1]; b[k+2]=a[k+2];
      }
  }

  public int getInputs() { return 1; }
  public int getOutputs() { return 1; }
}
