package nxm.ucl.lib;//remove for non-nxm use
import java.io.*;
import java.net.*;
import java.net.InetAddress;

/**
  * Web to Gui Connector
  * @author "Mike Warnock - Comp. Sci. Trainee"
  * @version "1.0"
  * Seriously modified by MSZ - Sr. Comp Sci
 */

public class JavaRMIFCon
{
  // packet message functions
  public static final byte
        SET=101, GET=102,               // for results access
        RET=103, ACK=104,               // for results access
        OPEN=105, CLOSE=106,            // open/close channel
        SEND=107, RECV=108,             // message access
        PING=109, PONG=110,             // keep alive checks
        DHDR=111, DBUF=112,             // file data access
        ADDR=113, MODIFY=114,           // address, modify
        OPENED=115, CLOSED=116,         // response to OPEN,CLOSE
        DBUFC=117, DBUFD=118,           // file data access
        GETPROP=121, RETPROP=122,       // published keyname access
        PKTSEND=125, PKTSYNC=126,       // low-level RDP hooks
        DROPPED=0, RECEIPT=123;         // dropped remote state

  // packet header byte offsets
  public static final byte FUNC=0, FLAG=1, INFO=2, REP=3, SEQ=4, TRY=5, RPT=6, ADJ=7, DATA=8;
  public int MaxRetries = 2;
  public int socktimeout = 500; //should be local anyway

  private DatagramPacket dpGui;
  private String localhost;
  private byte buf[];

  public static void main(String[] args)
  {
    JavaRMIFCon wg = new JavaRMIFCon("e2w11");
    String strSend = "MSGNAME=MJWJRCOMPSCI,FIELD1=MIKE,FIELD2=WORKS,MSGID=MJ,FROM=MIKE,MSGID=MJW,ID=ME";
    wg.sendCommand(strSend,"localhost",7001,"ME");
  }

  public void TraceMessage(String strInMsg)
  {
    try {
      System.out.println(strInMsg);
    } catch (Exception e) {
      System.err.println("JavaRMIFCon()::TraceMessage - Error:"+ e);
    }
    return;
  }

  public JavaRMIFCon(String localhost) {
    this.localhost=localhost;
    return;
  }

  public int sendCommand(String strCmd,String m_host,int m_port,String infid)
  {
    DatagramSocket sock;
    try {
        sock = new DatagramSocket();
        sock.setSoTimeout(socktimeout);
        String fid = "";
        if (infid.length()>0) { fid="FROMID="+infid+","; }
        String strSend = "{" + fid + strCmd + ",REPLYHP="+localhost+":"+sock.getLocalPort()+"}";
        TraceMessage("JavaRMIFCon::sendCommand - Sending "+ strSend + " to "+m_host+"/"+m_port);
        byte[] bySend = strSend.getBytes();
        int nSendLen = bySend.length + DATA;
        buf = new byte[nSendLen];
        dpGui = new DatagramPacket(buf,nSendLen);
        for( int i=0; i<nSendLen; i++) buf[i] = 0;
        buf[FUNC] = SET;
        buf[FLAG] = 0;
        buf[INFO] =1;
        buf[REP ] = 5;
        buf[SEQ] = 5;
        System.arraycopy (bySend,0, buf,DATA,nSendLen-DATA);
        dpGui.setPort(m_port);
        dpGui.setAddress(InetAddress.getByName(m_host));
        sock.send(dpGui);
        int nRecvLen = 0;
        int nRetries = 0;
        try {
           byte[] ibuf = new byte[256];
           dpGui = new DatagramPacket(ibuf,256);
           dpGui.setLength(256);
           while (nRecvLen == 0 && nRetries < MaxRetries) {
             if (nRetries>0) TraceMessage("JavaRMIFCon::sendCommand - Waiting for RECEIPT");
             try {
               sock.receive(dpGui);
             } catch (SocketTimeoutException ste) { nRetries++; continue; }
             nRecvLen =  dpGui.getLength();
             nRetries++;
           }
        } catch(SocketException e) {TraceMessage("JavaRMIFCon::sendCommand - Receive recv err" +e);}
        catch(Exception e) {TraceMessage("JavaRMIFCon::sendCommand - Receive recv err" + e);}

        if (nRecvLen > 0) {
           byte[] ibuf = dpGui.getData();
           String strRecv = new String(ibuf,DATA,dpGui.getLength());
//           TraceMessage("JavaRMIFCon::sendCommand - Received " +nRecvLen + " bytes "+ ibuf[FUNC] + "-"+ibuf[SEQ] + " " + strRecv);
        }

        try {
          sock.close();
        } catch(Exception e) {}
    } catch (Exception e) {
      TraceMessage("JavaRMIFCon::sendCommand - Error while processing "+ m_host + ":" + m_port +" :"+ e);
    }
//    TraceMessage("JavaRMIFCon::sendCommand - Done");
    return 0;
  }
}
