#ifndef XM_MTYPES_H_
/*
 ************

   $Id: mtypes.h,v 1.3 2009/08/11 00:25:53 ntn Exp $

   Description: Includes Midas SYS area version constants and defines the
   M_PTR pointer struct type for storing pointers in FORTRAN structures.

   Author:	JGS 4/2/90

 ************
*/

#include "cdefs.h"
#include "xmversion.h"

/*
  pointer definition
*/
#define L_M_Ptr 8

#if defined(_64BIT)
#  define M_PTR_T int_u8
#  define L_M_Ptr_p 8
  typedef struct {
    int_u8 p;
  } M_PTR;

#else
#  define M_PTR_T int_u4
#  define L_M_Ptr_p 4
  typedef struct {
    int_u4 p;
    int_u4 fill;
  } M_PTR;
#endif

/*
  parameters
*/

#define L_max_ascii   80   /* max size of ascii result string */
#define L_max_resname 40   /* max size of results name */
#define L_big_string 1024  /* Size of long filenames etc. for XM46 */

#define XM_MTYPES_H_
#endif /* XM_MTYPES_H_ */
